﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using ThinkGeo.MapSuite.Core;

namespace WPFThinkgeo_Test1
{
    /// <summary>
    /// Logique d'interaction pour MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void mapSiane_Loaded(object sender, RoutedEventArgs e)
        {
            mapSiane.MapUnit = ThinkGeo.MapSuite.Core.GeographyUnit.Meter;
            var ov = new LayerOverlay();

            InMemoryFeatureLayer m = new InMemoryFeatureLayer();
            m.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            m.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Orange, 2);            

            var source = new Uri("pack://application:,,,/WPFThinkgeo_Test1;component/Icon3.png", UriKind.Absolute);

            //Uri in image source ==> OK
            this.image.Source = new BitmapImage(source);

            //m.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Square,GeoColor.SimpleColors.Orange, 15f);            

            //Uri in WpfGeoImage source ==> NOT OK
            m.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(new WpfGeoImage(source));

            
            ov.Layers.Add("Test",m);
            mapSiane.Overlays.Add(ov);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            mapSiane.TrackOverlay.TrackEnded += new EventHandler<TrackEndedTrackInteractiveOverlayEventArgs>(TrackEndedTrackInteractiveOverlay);
            mapSiane.TrackOverlay.TrackMode = TrackMode.Point;
        }

        internal void TrackEndedTrackInteractiveOverlay(object sender, TrackEndedTrackInteractiveOverlayEventArgs e)
        {
            InMemoryFeatureLayer m = (InMemoryFeatureLayer)mapSiane.FindFeatureLayer("Test");
            m.InternalFeatures.Add(e.TrackShape.GetFeature());

            if (!mapSiane.TrackOverlay.TrackShapeLayer.IsOpen) mapSiane.TrackOverlay.TrackShapeLayer.Open();
            mapSiane.TrackOverlay.TrackShapeLayer.Clear();
            mapSiane.TrackOverlay.TrackEnded -= new EventHandler<TrackEndedTrackInteractiveOverlayEventArgs>(TrackEndedTrackInteractiveOverlay);
            mapSiane.TrackOverlay.TrackMode = TrackMode.None;
            mapSiane.Refresh();

        }
    }
}
